__author__  = 'Oberon IT <alle@oberon.no>'

from Acquisition import aq_base
from Products.Archetypes.interfaces.base import IBaseUnit
from Products.Archetypes.Marshall import Marshaller
from types import StringType, ListType, TupleType

class ScoutRFC822Marshaller(Marshaller):

    def demarshall(self, instance, data, **kwargs):
     try:
        from Products.CMFDefault.utils import parseHeadersBody
        headers, body = parseHeadersBody(data)
        for k, v in headers.items():
#	    print "demarshalling "+k+": "+v
            k = k.lower()
            if v.strip() == 'None':
                v = None
            field = instance.getField(k)
            if field is not None:
                mutator = field.getMutator(instance)
                if mutator is not None:
		    try:
                        mutator(v)
		    except Exception, info:
			# could be baad, but we can't help it
                        print "Exception when calling mutator "+str(mutator)+": "+str(info)
			pass
                    except:
                        import sys
                        print "Non-Exception exception when calling mutator "+str(mutator)
                        print sys.exc_info()[1]
                        pass
        content_type = headers.get('Content-Type', 'text/plain')
        if not kwargs.get('mimetype', None):
            kwargs.update({'mimetype': content_type})
        p = instance.getPrimaryField()
        if p is not None:
            mutator = p.getMutator(instance)
            if mutator is not None:
                mutator(body, **kwargs)
     except Exception, args:
	print "OUGH! Demarshalling exception: "+str(args)

    def marshall(self, instance, **kwargs):
        from Products.CMFDefault.utils import formatRFC822Headers
        p = instance.getPrimaryField()
        body = p and instance[p.getName()] or ''
        pname = p and p.getName() or None
        content_type = length = None
        # Gather/Guess content type
        if IBaseUnit.isImplementedBy(body):
            content_type = str(body.getContentType())
            body   = body.getRaw()
        else:
            if p and hasattr(p, 'getContentType'):
                content_type = p.getContentType(instance) or 'text/plain'
            else:
                content_type = body and guess_content_type(body) or 'text/plain'

        headers = {}
        fields = [f for f in instance.Schema().fields()
                  if f.getName() != pname]
        for field in fields:
	    # allowDiscussion doesn't demarshall, so don't marshall it
	    if field.getName() != "allowDiscussion":
                value = instance[field.getName()]
                if type(value) in [ListType, TupleType]:
#		    print "List or tuple..."
                    value = '\n'.join([str(v) for v in value])
                headers[field.getName()] = str(value).replace("\r","")

        headers['Content-Type'] = content_type or 'text/plain'

        header = formatRFC822Headers(headers.items())
        data = '%s\n\n%s' % (header, body)
        length = len(data)

        return (content_type, length, data)
